# Library Sandbox

## Assembly
 - A beamer and a monitor must be pluged to the pc (2 outputs needed for the calibration)
 - The camera must be pluged with an usb 3.0 extension (otherwise the resolution of the frames will be lowered)

## Depedencies
 - OS : Ubuntu 18.04
 - C++ : 11.0
 - g++ : 7.5.0
 - OpenCV : 3.2.0
 - librealsense 2 : 2.35.2
 - yaml-cpp : https://github.com/jbeder/yaml-cpp @commit : 9fb51534877d16597cfd94c18890d87af0879d65
 - Qt : 5.9.5

## Makefile
 - make lib : build the librairy
 - make apps : build the setup application
 - make clean : clean all generated files

## Makefile for applications
Examples can be found in the project ar_sandbox_app

### Compilation
You need to specify :
 - The path (can be relative) to the headers of the classes in the project with the parameter -I (this is an upper case i)

### Linker
You need to specify :
 - The path (can be relative) to the generated shared object library (file .so) with the parameter -L
 - The flag of the generated library (-lsandbox in our case)
 - The flags of the libraries used in the project for the linker, which are availible throught the variable DEP_SANDBOX in file dep.mk

## Before launching your application
 - LD_LIBRARY_PATH must contain the path to the directory containing libsandbox.so (which is generated in /build)
 - Enter the command below in the terminal executing your applications
 - Where $REALTIVE_PATH_TO_SO is the relative path to the generated file libsandbox.so from the current path of your terminal

```
export LD_LIBRARY_PATH=$(pwd)/$RELATIVE_PATH_TO_SO
```
 - Don't forget that LD_LIBRARY_PATH is local to each terminal


If the ld variable is not set correctly or the library is not generated, this error will show up :
```
/usr/bin/ld : cannot find -lsandbox
collect2: error: ld returned 1 exit status
```
